#ifndef __arch_avm_reboot_status_brcma_h__
#define __arch_avm_reboot_status_brcma_h__

#define UPDATE_REBOOT_STATUS_TEXT       "(c) AVM 2015, Reboot Status is: Firmware-Update" \
                                        "(c) AVM 2015, Reboot Status is: Firmware-Update" \
                                        "(c) AVM 2015, Reboot Status is: Firmware-Update"
#define SOFTWATCHDOG_REBOOT_STATUS_TEXT "(c) AVM 2015, Reboot Status is: Software-Watchdog" \
                                        "(c) AVM 2015, Reboot Status is: Software-Watchdog" \
                                        "(c) AVM 2015, Reboot Status is: Software-Watchdog"
#define SOFT_REBOOT_STATUS_TEXT         "(c) AVM 2015, Reboot Status is: Software-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Software-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Software-Reboot"
#define NMI_REBOOT_STATUS_TEXT          "(c) AVM 2015, Reboot Status is: Software-NMI-Watchdog" \
                                        "(c) AVM 2015, Reboot Status is: Software-NMI-Watchdog" \
                                        "(c) AVM 2015, Reboot Status is: Software-NMI-Watchdog"
#define POWERON_REBOOT_STATUS_TEXT      "(c) AVM 2015, Reboot Status is: Power-On-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Power-On-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Power-On-Reboot"
#define TEMP_REBOOT_STATUS_TEXT         "(c) AVM 2015, Reboot Status is: Temperature-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Temperature-Reboot" \
                                        "(c) AVM 2015, Reboot Status is: Temperature-Reboot"

#include <linux/avm_kernel_config.h>

extern void *avm_boot_string_virt_addr;
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static char *arch_get_mailbox(void){
    return (char *)avm_boot_string_virt_addr;
}
#if defined(CONFIG_AVM_FASTIRQ)
static int fastirq_dump_once = 0;
/**--------------------------------------------------------------------------------**\
\**--------------------------------------------------------------------------------**/
static int arch_brcma_die_notifier(struct notifier_block *self __maybe_unused, unsigned long cmd, void *ptr) {
    struct die_args *args = (struct die_args *)ptr;
    struct pt_regs *regs = args->regs;
    if(cmd == DIE_OOPS) {
        fastirq_dump_once = 1;
        avm_fiq_dump_stat();
        printk(KERN_ERR"\nBacktrace of all CPU's:");
        avm_trigger_all_cpu_backtrace(regs);
        printk(KERN_ERR"\nBacktrace of all CPU's done\n\n");
    }
    return NOTIFY_OK;
}
#define arch_die_notifier arch_brcma_die_notifier

/**--------------------------------------------------------------------------------**\
\**--------------------------------------------------------------------------------**/
static int arch_brcma_panic_notifier(struct notifier_block *notifier_block __maybe_unused, unsigned long event __maybe_unused, void *cause_string __maybe_unused) {
    if(fastirq_dump_once == 0) {
        avm_fiq_dump_stat();
    }
    return NOTIFY_OK;
}
#define arch_panic_notifier arch_brcma_panic_notifier
#endif/*--- #if defined(CONFIG_AVM_FASTIRQ) ---*/

#endif /*--- #ifndef __arch_avm_reboot_status_brcma_h__ ---*/
