/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
#include <linux/version.h>
#include <linux/proc_fs.h>
#include <linux/timer.h>
#include <linux/sched.h>
#include <linux/mm.h>
#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/avm_profile.h>
#include <linux/avm_debug.h>
#include <linux/kallsyms.h>
#include <asm/uaccess.h>

#include "avm_profile.h"

static const struct _cpucore_profile x86_cpu_config[2] = {
    { cpu_nr_offset: 0, vpe_nr: 1, next_core: &x86_cpu_config[1] },
    { cpu_nr_offset: 1, vpe_nr: 1, next_core: NULL },
};

/*--------------------------------------------------------------------------------*\
 * liefert Anzahl der Performance-Counter
\*--------------------------------------------------------------------------------*/
static unsigned int x86_get_performance_counter_nr(void){
    return 0;
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
int x86_get_performance_counter_mode(char *str, int str_len, unsigned int nr __maybe_unused){
    if(str_len) str[0] = 0;
    return 0;
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static void x86_performance_counter_action(char *p __attribute__((unused))) {
}

/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
void x86_performance_counter_help(struct seq_file *seq __maybe_unused) {
}
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
static int __init arch_x86_profiler_init(void) {
    cpu_nr_to_tc_and_core[0].core = 0;
    cpu_nr_to_tc_and_core[0].tc   = 0;
    cpu_nr_to_tc_and_core[1].core = 1;
    cpu_nr_to_tc_and_core[1].tc   = 0;

    arch_profile_ctrl.cpu_profile                   = x86_cpu_config;
    arch_profile_ctrl.performance_counter_action    = x86_performance_counter_action;
    arch_profile_ctrl.performance_counter_help      = x86_performance_counter_help;
    arch_profile_ctrl.get_performance_counter_nr    = x86_get_performance_counter_nr;
    arch_profile_ctrl.get_performance_counter_mode  = x86_get_performance_counter_mode;
    return 0;
}
late_initcall(arch_x86_profiler_init);
